operator
	//Functions
	function
		VAR //Define a variable
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				var/Variable/result = new()
				if(istype(argument,/String))
					var/String/String = argument
					var/start = copytext(String.text,1,2)
					if(known[start])
						known[start] += String.text
					else
						known[start] = list(String.text)
					variables[String.text] = result
				return symbols.Copy(1, position) + result + symbols.Copy(partner_pos+1, 0)

		VEC //Create a vector by magnitude and direction
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Vector/V = new()
				var/Scalar/magnitude = arguments[1]
				var/Scalar/direction = arguments[2]
				V.components = list(magnitude.real*cos(direction.real), magnitude.real*Sin(direction.real))
				return symbols.Copy(1, position) + V + symbols.Copy(partner_pos+1, 0)
		VECC //Create a vector by components
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Vector/V = new()
				for(var/Scalar/S in arguments)
					V.components += S.real
				return symbols.Copy(1, position) + V + symbols.Copy(partner_pos+1, 0)
		LIST //Create a list
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/List/L = new()
				for(var/S in arguments)
					L.elements += S
				return symbols.Copy(1, position) + L + symbols.Copy(partner_pos+1, 0)

		SQRT
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				var/Scalar/exponent = new()
				exponent.real = 1/2
				var/insert[] = list(argument,new/operator/exponent,exponent)
				return symbols.Copy(1, position) + insert + symbols.Copy(partner_pos+1, 0)
		SIN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = Sin(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		COS
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = cos(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		TAN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = Sin(argument.real)/cos(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		SINH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = sinh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		COSH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = cosh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		TANH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = sinh(argument.real)/cosh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCSIN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arcsin(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCCOS
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arccos(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCTAN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arctan(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCSINH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arcsinh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCCOSH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arccosh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ARCTANH
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = arctanh(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		LN		//Natural Log
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = log(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		LOG		//Common Log
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = log(10,argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		LOGX
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/S = new()
				var/Scalar/first = arguments[1]
				var/Scalar/second = arguments[2]
				S.real = log(first.real,second.real)
				return symbols.Copy(1, position) + S + symbols.Copy(partner_pos+1, 0)
		ABS		//Absolute value
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = abs(argument.real)
				argument.imaginary = abs(argument.imaginary)
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		MAG		//Magnitude
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				//world.log << position
				//world.log << partner_pos
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				if(istype(argument,/Scalar))
					argument.real = argument.magnitude()
					argument.imaginary = 0
					return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
				else if(istype(argument,/Vector))
					var/Scalar/S = new()
					S.real = argument.magnitude()
					return symbols.Copy(1, position) + S  + symbols.Copy(partner_pos+1, 0)
		CONJ
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				return symbols.Copy(1, position) + argument.conjugate() + symbols.Copy(partner_pos+1, 0)
		FAC
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = factorial(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		INT
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				var/real = argument.real
				var/imaginary = argument.real
				argument.real = round(argument.real)
				argument.imaginary = round(argument.imaginary)
				if(argument.real < 0)
					if(real != argument.real)
						argument.real += 1
				if(argument.imaginary < 0)
					if(imaginary != argument.imaginary)
						argument.imaginary += 1
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		ROUND
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = round(argument.real, 1)
				argument.imaginary = round(argument.imaginary, 1)
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		MAX
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/maximum
				for(var/Scalar/S in arguments)
					if(!maximum || (S.magnitude() > maximum.magnitude()))
						maximum = S
				return symbols.Copy(1, position) + maximum + symbols.Copy(partner_pos+1, 0)
		MIN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/minimum
				for(var/Scalar/S in arguments)
					if(!minimum || (S.magnitude() < minimum.magnitude()))
						minimum = S
				return symbols.Copy(1, position) + minimum + symbols.Copy(partner_pos+1, 0)
		FLOOR
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				argument.real = round(argument.real)
				argument.imaginary = 0
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		CEIL
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/Scalar/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				var/old = argument.real
				argument.real = round(argument.real)
				if(old != argument.real)
					argument.real += 1
				return symbols.Copy(1, position) + argument + symbols.Copy(partner_pos+1, 0)
		SUM
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/sum = new()
				for(var/Scalar/S in arguments)
					sum.real += S.real
					sum.imaginary += S.imaginary
				return symbols.Copy(1, position) + sum + symbols.Copy(partner_pos+1, 0)
		AVG
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/sum = new()
				for(var/Scalar/S in arguments)
					sum.real += S.real
					sum.imaginary += S.imaginary
				sum.real /= arguments.len
				sum.imaginary /= arguments.len
				return symbols.Copy(1, position) + sum + symbols.Copy(partner_pos+1, 0)
		BC
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/S = new()
				var/Scalar/first = arguments[1]
				var/Scalar/second = arguments[2]
				S.real = bc(first.real, second.real)
				return symbols.Copy(1, position) + S + symbols.Copy(partner_pos+1, 0)
		RAND
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/arguments[] = find_arguments(symbols, position, partner_pos)
				var/Scalar/S = new()
				var/Scalar/first = arguments[1]
				var/Scalar/second = arguments[2]
				S.real = rand(first.real, second.real)
				return symbols.Copy(1, position) + S + symbols.Copy(partner_pos+1, 0)
		LEN
			operate(list/symbols, position)
				var/partner_pos = symbols.Find(partner)
				var/String/argument = a_Evaluate(symbols.Copy(position+1, partner_pos))
				var/Scalar/S = new()
				if(istype(argument,/String))
					S.real = argument.len()
				else if(istype(argument,/List))
					S.real = argument.len()
				return symbols.Copy(1, position) + S + symbols.Copy(partner_pos+1, 0)