//Here are all of the operators that SET can use
operator
	var
		partner			//Some operators have a "partner"... specifically ? and (
	proc
		operate(list/symbols)
			return symbols		//By default, do nothing to the list

	//Operators
	parenthesis
		close
		operate(list/symbols, position)
			var/partner_pos = symbols.Find(partner)
			return symbols.Copy(1, position) + a_Evaluate(symbols.Copy(position+1, partner_pos)) + symbols.Copy(partner_pos+1, 0)

	binary_not
		operate(list/symbols, position)
			var/Scalar/next = symbols[position + 1]
			var/datum/result
			if(istype(next,/Scalar))
				result = new/Scalar
				result:real = ~next.real
			return symbols.Copy(1, position) + result + symbols.Copy(position + 2, 0)
	logical_not
		operate(list/symbols, position)
			var/Scalar/next = symbols[position + 1]
			var/datum/result
			if(istype(next,/Scalar))
				result = new/Scalar
				result:real = !next.real && !next.imaginary
			else if(istype(next,/String))
				result = new/Scalar
				result:real = !next:text
			else if(istype(next,/List))
				result = new/Scalar
				var/List/L = next
				result:real = !length(L.elements)
			return symbols.Copy(1, position) + result + symbols.Copy(position + 2, 0)
	negative
		operate(list/symbols, position)
			var/Scalar/next = symbols[position + 1]
			var/datum/result = negate(next)
			return symbols.Copy(1, position) + result + symbols.Copy(position + 2, 0)

	exponent
		operate(list/symbols, position)
			var/Scalar/number = symbols[position - 1]
			var/Scalar/exponent = symbols[position + 1]
			var/datum/result = exponent(number, exponent)
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	union
		operate(list/symbols, position)
			var/List/first = symbols[position - 1]
			var/List/second = symbols[position + 1]
			var/List/result
			if(istype(first,/List) && istype(second,/List))
				result = new()
				for(var/i in first.elements+second.elements)
					if(!inlist(i, result))
						result.elements += i
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	intersect
		operate(list/symbols, position)
			var/List/first = symbols[position - 1]
			var/List/second = symbols[position + 1]
			var/List/result
			if(istype(first,/List) && istype(second,/List))
				result = new()
				for(var/i in first.elements)
					if(inlist(i, second))
						result.elements += i
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	multiply
		var/vector = "dot"
		operate(list/symbols, position)
			var/Scalar/multiplier = symbols[position - 1]
			var/Scalar/multiplicand = symbols[position + 1]
			var/datum/result = choose_multiply(multiplier, multiplicand, vector)
			return symbols.Copy(1, position - 1) + result + symbols.Copy(position + 2, 0)
		cross
			vector = "cross"
	divide
		operate(list/symbols, position)
			var/Scalar/divisor = symbols[position - 1]
			var/Scalar/dividend = symbols[position + 1]
			var/datum/result = divide(divisor, dividend)
			return symbols.Copy(1, position - 1) + result + symbols.Copy(position + 2, 0)
	mod
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result = mod(first, second)
			return symbols.Copy(1, position - 1) + result + symbols.Copy(position + 2, 0)

	add
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result = add(first, second)
			return symbols.Copy(1, position - 1) + result + symbols.Copy(position + 2, 0)
	subtract
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result = subtract(first, second)
			return symbols.Copy(1, position - 1) + result + symbols.Copy(position + 2, 0)

	less
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				if(first.imaginary || second.imaginary)//If either is complex, use magnitude
					result:real = first.magnitude() < second.magnitude()
				else
					result:real = first.real < second.real
			else if(istype(first,/String) && istype(second,/String))
				result = new/Scalar
				result:real = first:text < second:text
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	less_equal
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				if(first.imaginary || second.imaginary)//If either is complex, use magnitude
					result:real = first.magnitude() <= second.magnitude()
				else
					result:real = first.real <= second.real
			else if(istype(first,/String) && istype(second,/String))
				result = new/Scalar
				result:real = first:text <= second:text
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	greater
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				if(first.imaginary || second.imaginary)//If either is complex, use magnitude
					result:real = first.magnitude() > second.magnitude()
				else
					result:real = first.real > second.real
			else if(istype(first,/String) && istype(second,/String))
				result = new/Scalar
				result:real = first:text > second:text
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	greater_equal
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				if(first.imaginary || second.imaginary)//If either is complex, use magnitude
					result:real = first.magnitude() >= second.magnitude()
				else
					result:real = first.real >= second.real
			else if(istype(first,/String) && istype(second,/String))
				result = new/Scalar
				result:real = first:text >= second:text
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	shift_left
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				result:real = first.real<<second.real
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	shift_right
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				result:real = first.real>>second.real
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	equal
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result = new/Scalar()
			result:real = equal(first,second)
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	not_equal
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result = new/Scalar()
			result:real = !equal(first,second)
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	in_op
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/List/second = symbols[position + 1]
			var/datum/result
			if(istype(second,/List))
				result = new/Scalar
				result:real = inlist(first,second)
			else if (istype(first,/String) && istype(second,/String))
				result = new/Scalar
				if(findText(second:text,first:text))
					result:real = 1
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	binary_and
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				result:real = first.real&second.real
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	binary_or
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				result:real = first.real|second.real
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)
	binary_xor
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Scalar) && istype(second,/Scalar))
				result = new/Scalar
				result:real = first.real^second.real
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	and
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/e_first
			var/e_second
			if(istype(first,/Scalar))
				e_first = first.magnitude()
			else if(istype(first,/String))
				e_first = !(!first:text)
			if(istype(second,/Scalar))
				e_second = second.magnitude()
			else if(istype(second,/String))
				e_second = !(!second:text)
			var/Scalar/result = new()
			result.real = e_first && e_second
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	or
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/e_first
			var/e_second
			if(istype(first,/Scalar))
				e_first = first.magnitude()
			else if(istype(first,/String))
				e_first = !(!first:text)
			if(istype(second,/Scalar))
				e_second = second.magnitude()
			else if(istype(second,/String))
				e_second = !(!second:text)
			var/Scalar/result = new()
			result.real = e_first || e_second
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)

	question
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/Scalar/third = symbols[symbols.Find(partner) + 1]
			var/datum/result
			if(istype(first,/Scalar))
				if(first.magnitude())
					result = second
				else
					result = third
			else if(istype(first,/String))
				result = new/Scalar
				if(first:text)
					result = second
				else
					result = third
			return symbols.Copy(1, position-1) + result + symbols.Copy(symbols.Find(third) + 1, 0)

	set_equal
		operate(list/symbols, position)
			var/Scalar/first = symbols[position - 1]
			var/Scalar/second = symbols[position + 1]
			var/datum/result
			if(istype(first,/Variable))
				var/Variable/V = first
				result = second
				V.value = second
			return symbols.Copy(1, position-1) + result + symbols.Copy(position + 2, 0)



	question_partner	//Not a real operator, but it plays one on TV.
	comma				//Also not real.  Used to seperate multiple arguments to a function

proc/find_arguments(list/Symbols, start, end)
	var/buffer[] = list()
	var/arguments[] = list()
	var/count = 0
	for(var/i in (start+1) to (end-1))
		var/operator/current = Symbols[i]
		if(current.type==/operator/parenthesis || istype(current, /operator/function)) count++
		if(current.type==/operator/parenthesis/close) count--
		if(count==0 && istype(current,/operator/comma))
			arguments += a_Evaluate(buffer)
			buffer = list()
		else
			buffer += current
	arguments += a_Evaluate(buffer)
	return arguments